blob: 1f1d7d323593d51ec6deceb73017d750bc7edd45 [file] [log] [blame]
Phaneendra Manda4c62c802019-03-06 21:37:49 +05301#
2# Copyright 2016 the original author or authors.
3#
4# Licensed under the Apache License, Version 2.0 (the "License");
5# you may not use this file except in compliance with the License.
6# You may obtain a copy of the License at
7#
8# http://www.apache.org/licenses/LICENSE-2.0
9#
10# Unless required by applicable law or agreed to in writing, software
11# distributed under the License is distributed on an "AS IS" BASIS,
12# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13# See the License for the specific language governing permissions and
14# limitations under the License.
15#
16
Matt Jeanneret8b823f62019-05-11 11:01:28 -040017# set default shell
18SHELL = bash -e -o pipefail
19
20# Variables
21VERSION ?= $(shell cat ./VERSION)
22
Matt Jeanneretf880eb62019-07-16 20:08:03 -040023DOCKER_LABEL_VCS_DIRTY = false
24ifneq ($(shell git ls-files --others --modified --exclude-standard 2>/dev/null | wc -l | sed -e 's/ //g'),0)
25 DOCKER_LABEL_VCS_DIRTY = true
26endif
Matt Jeanneret8b823f62019-05-11 11:01:28 -040027## Docker related
Matt Jeanneretf880eb62019-07-16 20:08:03 -040028DOCKER_EXTRA_ARGS ?=
Matt Jeanneret8b823f62019-05-11 11:01:28 -040029DOCKER_REGISTRY ?=
30DOCKER_REPOSITORY ?=
David K. Bainbridge96b06512021-04-01 18:53:51 +000031DOCKER_TAG ?= ${VERSION}$(shell [[ ${DOCKER_LABEL_VCS_DIRTY} == "true" ]] && echo "-dirty" || true)
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -040032ADAPTER_IMAGENAME := ${DOCKER_REGISTRY}${DOCKER_REPOSITORY}voltha-openolt-adapter:${DOCKER_TAG}
David K. Bainbridge96b06512021-04-01 18:53:51 +000033DOCKER_TARGET ?= prod
Andrea Campanellacbf583e2019-12-17 15:26:00 -080034TYPE ?= minimal
Matt Jeanneret8b823f62019-05-11 11:01:28 -040035
36## Docker labels. Only set ref and commit date if committed
Matt Jeanneretf880eb62019-07-16 20:08:03 -040037DOCKER_LABEL_VCS_URL ?= $(shell git remote get-url $(shell git remote))
38DOCKER_LABEL_VCS_REF = $(shell git rev-parse HEAD)
39DOCKER_LABEL_BUILD_DATE ?= $(shell date -u "+%Y-%m-%dT%H:%M:%SZ")
40DOCKER_LABEL_COMMIT_DATE = $(shell git show -s --format=%cd --date=iso-strict HEAD)
Matt Jeanneret8b823f62019-05-11 11:01:28 -040041
Matt Jeanneretf880eb62019-07-16 20:08:03 -040042DOCKER_BUILD_ARGS ?= \
43 ${DOCKER_EXTRA_ARGS} \
44 --build-arg org_label_schema_version="${VERSION}" \
45 --build-arg org_label_schema_vcs_url="${DOCKER_LABEL_VCS_URL}" \
46 --build-arg org_label_schema_vcs_ref="${DOCKER_LABEL_VCS_REF}" \
47 --build-arg org_label_schema_build_date="${DOCKER_LABEL_BUILD_DATE}" \
48 --build-arg org_opencord_vcs_commit_date="${DOCKER_LABEL_COMMIT_DATE}" \
49 --build-arg org_opencord_vcs_dirty="${DOCKER_LABEL_VCS_DIRTY}"
50
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -050051# tool containers
David K. Bainbridge2f2658d2021-04-09 16:13:57 +000052VOLTHA_TOOLS_VERSION ?= 2.4.0
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -050053
Kent Hagerman52830082020-02-14 14:53:52 -050054GO = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golang go
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -050055GO_JUNIT_REPORT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-go-junit-report go-junit-report
Matteo Scandolod5c22402020-11-23 14:28:37 -080056GOCOVER_COBERTURA = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app/src/github.com/opencord/voltha-openolt-adapter -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-gocover-cobertura gocover-cobertura
Kent Hagerman52830082020-02-14 14:53:52 -050057GOLANGCI_LINT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golangci-lint golangci-lint
58HADOLINT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-hadolint hadolint
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -050059
Zack Williams75662252020-04-06 18:16:54 -070060.PHONY: docker-build local-protos local-lib-go help
61.DEFAULT_GOAL := help
Phaneendra Manda4c62c802019-03-06 21:37:49 +053062
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -040063## Local Development Helpers
Zack Williams75662252020-04-06 18:16:54 -070064local-protos: ## Copies a local version of the voltha-protos dependency into the vendor directory
William Kurkianea869482019-04-09 15:16:11 -040065ifdef LOCAL_PROTOS
Girish Gowdraa09aeab2020-09-14 16:30:52 -070066 rm -rf vendor/github.com/opencord/voltha-protos/v4/go
67 mkdir -p vendor/github.com/opencord/voltha-protos/v4/go
68 cp -r ${LOCAL_PROTOS}/go/* vendor/github.com/opencord/voltha-protos/v4/go
69 rm -rf vendor/github.com/opencord/voltha-protos/v4/go/vendor
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -040070endif
71
Zack Williams75662252020-04-06 18:16:54 -070072local-lib-go: ## Copies a local version of the voltha-lib-go dependency into the vendor directory
Scott Baker355d1742019-10-24 10:57:52 -070073ifdef LOCAL_LIB_GO
Girish Gowdra8a0bdcd2021-05-13 12:31:04 -070074 mkdir -p vendor/github.com/opencord/voltha-lib-go/v5/pkg
75 cp -r ${LOCAL_LIB_GO}/pkg/* vendor/github.com/opencord/voltha-lib-go/v5/pkg/
William Kurkianea869482019-04-09 15:16:11 -040076endif
Matt Jeanneret8b823f62019-05-11 11:01:28 -040077
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -040078## Docker targets
Zack Williams75662252020-04-06 18:16:54 -070079build: docker-build ## Alias for 'docker build'
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -040080
Matteo Scandolo6ec3c352020-04-29 15:27:03 -070081docker-build: local-protos local-lib-go ## Build openolt adapter docker image (set BUILD_PROFILED=true to also build the profiled image)
David K. Bainbridgee2d9b332021-04-15 00:11:51 +000082 docker build $(DOCKER_BUILD_ARGS) --target=${DOCKER_TARGET} --build-arg CGO_PARAMETER=0 -t ${ADAPTER_IMAGENAME} -f docker/Dockerfile.openolt .
Matteo Scandolo6ec3c352020-04-29 15:27:03 -070083ifdef BUILD_PROFILED
David K. Bainbridgee2d9b332021-04-15 00:11:51 +000084 docker build $(DOCKER_BUILD_ARGS) --target=dev --build-arg CGO_PARAMETER=1 --build-arg EXTRA_GO_BUILD_TAGS="-tags profile" -t ${ADAPTER_IMAGENAME}-profile -f docker/Dockerfile.openolt .
85endif
86ifdef BUILD_RACE
87 docker build $(DOCKER_BUILD_ARGS) --target=dev --build-arg CGO_PARAMETER=1 --build-arg EXTRA_GO_BUILD_TAGS="-race" -t ${ADAPTER_IMAGENAME}-rd -f docker/Dockerfile.openolt .
Matteo Scandolo6ec3c352020-04-29 15:27:03 -070088endif
Matteo Scandolo8f2b9572020-02-28 15:35:23 -080089
Zack Williams75662252020-04-06 18:16:54 -070090docker-push: ## Push the docker images to an external repository
Matt Jeanneret8b823f62019-05-11 11:01:28 -040091 docker push ${ADAPTER_IMAGENAME}
Matteo Scandolo24ed9672020-05-04 10:53:08 -070092ifdef BUILD_PROFILED
93 docker push ${ADAPTER_IMAGENAME}-profile
94endif
David K. Bainbridgee2d9b332021-04-15 00:11:51 +000095ifdef BUILD_RACE
96 docker push ${ADAPTER_IMAGENAME}-rd
97endif
Matt Jeanneret8b823f62019-05-11 11:01:28 -040098
Zack Williams75662252020-04-06 18:16:54 -070099docker-kind-load: ## Load docker images into a KinD cluster
Andrea Campanellacbf583e2019-12-17 15:26:00 -0800100 @if [ "`kind get clusters | grep voltha-$(TYPE)`" = '' ]; then echo "no voltha-$(TYPE) cluster found" && exit 1; fi
101 kind load docker-image ${ADAPTER_IMAGENAME} --name=voltha-$(TYPE) --nodes $(shell kubectl get nodes --template='{{range .items}}{{.metadata.name}},{{end}}' | sed 's/,$$//')
102
Matt Jeanneret8b823f62019-05-11 11:01:28 -0400103## lint and unit tests
Zack Williams75662252020-04-06 18:16:54 -0700104lint-dockerfile: ## Perform static analysis on Dockerfile
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500105 @echo "Running Dockerfile lint check ..."
106 @${HADOLINT} $$(find . -name "Dockerfile.*")
107 @echo "Dockerfile lint check OK"
108
Zack Williams75662252020-04-06 18:16:54 -0700109lint-mod: ## Verify the Go dependencies
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400110 @echo "Running dependency check..."
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500111 @${GO} mod verify
Scott Baker22c0e9c2019-11-26 08:11:29 -0800112 @echo "Dependency check OK. Running vendor check..."
113 @git status > /dev/null
Kent Hagermane71b52d2020-02-26 11:13:42 -0500114 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Staged or modified files must be committed before running this test" && git status -- go.mod go.sum vendor && exit 1)
115 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files must be cleaned up before running this test" && git status -- go.mod go.sum vendor && exit 1)
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500116 ${GO} mod tidy
117 ${GO} mod vendor
Scott Baker22c0e9c2019-11-26 08:11:29 -0800118 @git status > /dev/null
Kent Hagermane71b52d2020-02-26 11:13:42 -0500119 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Modified files detected after running go mod tidy / go mod vendor" && git status -- go.mod go.sum vendor && git checkout -- go.mod go.sum vendor && exit 1)
120 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files detected after running go mod tidy / go mod vendor" && git status -- go.mod go.sum vendor && git checkout -- go.mod go.sum vendor && exit 1)
Scott Baker22c0e9c2019-11-26 08:11:29 -0800121 @echo "Vendor check OK."
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400122
Zack Williams75662252020-04-06 18:16:54 -0700123lint: local-lib-go lint-mod lint-dockerfile ## Run all lint targets
David Bainbridge788e5202019-10-21 18:49:40 +0000124
Zack Williams75662252020-04-06 18:16:54 -0700125test: ## Run unit tests
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400126 @mkdir -p ./tests/results
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500127 @${GO} test -mod=vendor -v -coverprofile ./tests/results/go-test-coverage.out -covermode count ./... 2>&1 | tee ./tests/results/go-test-results.out ;\
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400128 RETURN=$$? ;\
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500129 ${GO_JUNIT_REPORT} < ./tests/results/go-test-results.out > ./tests/results/go-test-results.xml ;\
130 ${GOCOVER_COBERTURA} < ./tests/results/go-test-coverage.out > ./tests/results/go-test-coverage.xml ;\
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400131 exit $$RETURN
132
Zack Williams75662252020-04-06 18:16:54 -0700133sca: ## Runs static code analysis with the golangci-lint tool
Kent Hagermane71b52d2020-02-26 11:13:42 -0500134 @rm -rf ./sca-report
Girish Gowdru6a80bbd2019-07-02 07:36:09 -0700135 @mkdir -p ./sca-report
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500136 @echo "Running static code analysis..."
Andrea Campanella21fc1b42021-03-10 16:41:33 +0100137 @${GOLANGCI_LINT} run --deadline=6m --out-format junit-xml ./... | tee ./sca-report/sca-report.xml
Kent Hagermane71b52d2020-02-26 11:13:42 -0500138 @echo ""
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500139 @echo "Static code analysis OK"
Girish Gowdru6a80bbd2019-07-02 07:36:09 -0700140
Zack Williams75662252020-04-06 18:16:54 -0700141clean: distclean ## Removes any local filesystem artifacts generated by a build
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -0400142
Zack Williams75662252020-04-06 18:16:54 -0700143distclean: ## Removes any local filesystem artifacts generated by a build or test run
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500144 rm -rf ./sca-report
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -0400145
Zack Williams75662252020-04-06 18:16:54 -0700146mod-update: ## Update go mod files
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500147 ${GO} mod tidy
148 ${GO} mod vendor
Zack Williams75662252020-04-06 18:16:54 -0700149
150# For each makefile target, add ## <description> on the target line and it will be listed by 'make help'
151help: ## Print help for each Makefile target
152 @echo "Usage: make [<target>]"
153 @echo "where available targets are:"
154 @echo
155 @grep '^[[:alpha:]_-]*:.* ##' $(MAKEFILE_LIST) \
156 | sort | awk 'BEGIN {FS=":.* ## "}; {printf "%-25s : %s\n", $$1, $$2};'